#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # Plus proches voisins
# 
# On cherche à prédire la note d'un vin avec un modèle des plus proches voisins.

# In[1]:


get_ipython().run_line_magic('matplotlib', 'inline')


# In[2]:


from papierstat.datasets import load_wines_dataset
df = load_wines_dataset()
df.head()


# Les premières colonnes contiennent les composants du vins ou plutôt les résultats de mesures chimiques. Cela exclut la qualité et la couleur qui n'est pas une information numérique. On les appelle les **variables** ou **features**. C'est ce qui est connu au moment de faire une prédiction.

# In[3]:


X = df.drop(['quality', 'color'], axis=1)


# La colonne *qualité* est ce qu'on cherche à prédire.

# In[4]:


y = df['quality']


# On cale un modèle des plus proches voisins. Celui mémorise simplement tous les exemples. Le paramètre *n_neighbors* précise le nombre de voisins qui prennent pas à la prédiction. Dans notre cas, c'est juste 1.

# In[5]:


from sklearn.neighbors import KNeighborsRegressor
knn = KNeighborsRegressor(n_neighbors=1)
knn.fit(X, y)


# On regarde la prédiction pour un vin quelconque tiré de la base.

# In[6]:


import random
i = random.randint(0, df.shape[0]-1)
vin = X.iloc[i:i+1,:]
knn.predict(vin)


# On la compare à la note enregistrée dans la base.

# In[7]:


y[i]


# Tout se passe bien.

# In[8]:





# In[9]: